/* GCC */
#include<algorithm>
#include<iostream>
#include<cstdio>
#include<vector>
#include<cmath>
#define ll unsigned long long

using namespace std;

const int N = 60 + 1;
const int inf = -1;

int n;
ll m;

vector<ll> p;
vector<int> d[N], s;

bool is_square(ll a){
    ll s = sqrt((long double)a);
    return s*s == a;
}

ll sqrtll(ll a){
    return sqrt((long double)a);
}

ll init(ll m, int n){
    for(int i = 1; i <= n; ++i)
        for(int j = i; j <= n; j += i)
            d[j].push_back(i);
    if(m%2 == 0){
        p.push_back(2);
        s.push_back(0);
        while(m%2 == 0){
            m /= 2;
            ++s[0];
        }
    }
    ll start_m = m;
    for(ll i = 3; i <= (1<<27); i += 2){
        if(m%i == 0){
            p.push_back(i);
            s.push_back(0);
            while(m%i == 0){
                m /= i;
                ++s[s.size()-1];
            }
        }
    }
    if(m != 1){
        if(is_square(m)){
            p.push_back(sqrtll(m));
            s.push_back(2);
            return 1;
        }
        if(m < (1ll << 54)){
            p.push_back(m);
            s.push_back(1);
            return 1;
        }
        return m;
    }
    return 1;
}

ll binpow(ll a, ll s){
    ll ans = 1;
    while(s){
        if(s&1)
            ans *= a;
        a *= a;
        s >>= 1;
    }
    return ans;
}

ll c;
vector<ll> ans;
bool c_prime = true, fail = false;
ll prod=1;

bool can(ll a, ll b){
    return inf/a/b != 0;
}

void solve(int n, int pos=0){
    if(pos == p.size()){
        if(c == 1 && n != 1)
            return;
        if(c != 1){
            if(n == 1)
                return;
            if(n != 4 && d[n].size() > 2){
                fail = true;
                return;
            }
            if(c_prime){
                if(n >= 3){
                    c_prime = false;
                    ans.clear();
                }
                else{
                    ans.push_back(prod);
                    return;
                }
            }
            if(!c_prime && n != 4)
                return;
        }

        ans.push_back(prod);
        return;
    }
    for(int i = 0; i < d[n].size() && !fail; ++i){
        int v = d[n][i];
        if(v <= s[pos])
            continue;
        ll b = binpow(p[pos], v-1);
        prod *= b;
        solve(n/v, pos+1);
        prod /= b;
    }
}

//1000000016000000063 4

int main(){
    freopen("divisors.in", "r", stdin);
    freopen("divisors.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    cin >> m >> n;
    c = init(m, n);
    solve(n);
    sort(ans.begin(), ans.end());
    if(ans.size() == 0)
        cout << 0 << endl;
    else{
        cout << ans[0]*c;
        for(int i = 1; i < ans.size(); ++i)
            cout << ' ' << ans[i]*c;
        cout << endl;
    }
}
