/* GCC */
#include <bits/stdc++.h>

using namespace std;

struct factorisation {
    uint64_t primes[20] = {1};
    int powers[20] = {0};
    int len;
};

uint64_t power(uint64_t a, uint64_t b) {
    int res = 1;
    for (uint64_t i = 0; i<b; i++) {
        res = res*a;
    }
    return res;
}

uint64_t min_div(uint64_t a) {

    if (a%2 == 0) return 2;
    for (uint64_t res = 3, sqr = sqrt(a); res <= sqr; res += 2 ) {
        if (a % res == 0) return res;
    }

    return a;
}

factorisation factorise(uint64_t a) {
    factorisation res;

    int i = 0;

    do {
        res.primes[i] = min_div(a);

        while (a % res.primes[i] == 0) {
            a = a/res.primes[i];
            res.powers[i]++;
        }

        i++;

    } while (a > 1);

    res.len = i;

    return res;
}

uint64_t multiply(factorisation f) {
    uint64_t res = 1;
    for (int i = 0; i<f.len; i++) {
        res = res * power(f.primes[i], f.powers[i]);
    }


    return res;
}

uint64_t sigma(factorisation f) {
    uint64_t res = 1;

    for (int i = 0; i<f.len; i++) {
        res *= f.powers[i] + 1;
    }

    return res;
}

int k = 0;

int func(uint64_t arr[], int count, int n, factorisation f, factorisation m) {
    if (count == 1) {
        f.powers[f.len-1] = n - 1;
        for (int i = 0; i<f.len; i++) {
            if (f.powers[i] < m.powers[i])
                return -1;
        }
        arr[k] = multiply(f);
        k++;
        return 0;
    }


    for (int i = 2; i != n; i++) {
        if (n % i != 0) continue;

        f.powers[f.len - count] = i - 1;
        func(arr, count-1, n/i, f, m);
    }

    return 0;
}

void quicksort(uint64_t arr[], int left, int right) {
    int i = left, j = right;
    uint64_t etalon = arr[left + (right-left)/2];

    while (i<j) {

        while (arr[i] < etalon) i++;
        while (arr[j] > etalon) j--;

        if (i<=j) {
            swap(arr[i], arr[j]);
            i++;
            j--;
        }

    }

    if (i > left) quicksort(arr, left, j);
    if (j < right) quicksort(arr, i, right);
}



int main()
{
    freopen("divisors.in", "r", stdin);
    freopen("divisors.out", "w", stdout);

    uint64_t m;
    int n;

    cin>>m>>n;

    factorisation m_fact = factorise(m);
    uint64_t arr[100] = {0};

    func(arr, m_fact.len, n, m_fact, m_fact);

    if (k == 0) {
        cout<<0<<"\n";
        return 0;
    }
    quicksort(arr, 0, k-1);
    for (int i = 0; i<k-1; i++) cout<<arr[i]<<" ";
    cout<<arr[k-1]<<"\n";
    return 0;
}
